Subject: bug#9891: 24.0.90; Duplicated entry at the info directory

From: Stefan Monnier <[email-masked]>
Date: Wed, 02 Nov 2011 15:52:54 -0400

>> I think I'm beginning to understand: the problem is that the "top-level
>> dir" is used in two very different contexts:
>> - for interactive use, where it should be shortish and avoid redundancy.
>> - for non-interactive use, typically to make `info' emulate `man', where
>> the toplevel `dir' is abused as an index.  This only works for
>> specially built `dir' files and I don't see it used in Debian,
>> for instance.
>> The Info-dir-remove-duplicates is clearly meant for the first use and
>> I think that's the most important use, so if we want to make it handle
>> the second case we'll have to make sure it doesn't hurt the first.
> What would constitute "hurting the first use case"?

An example of hurting the first use case would be to keep "* GDB: (gdb)"
along with "* Gdb: (gdb)".

> I intend to make a change whereby the header lines we maintain on
> Emacs's info/dir file are not deleted (by removing ("Emacs . "Emacs)
> from Info-streamline-headers) -- would that "hurt", and if so, why?

I added that code because I bumped into different dir entries which used
slightly different header lines for fundamentally the same purpose.
E.g. my current /usr/share/info/dir contains:

   Emacs
   * Ada mode: (emacs-21/ada-mode).
                                   The GNU Emacs mode for editing Ada.
   [...]
   Emacs editing modes
   * Ada mode: (emacs-23/ada-mode).
                                   Emacs mode for editing and compiling Ada code.
   [...]
   Emacs network features
   [...]
   * TRAMP: (emacs-23/tramp).      Transparent Remote Access, Multiple Protocol 
                                     Emacs remote file access via rsh and rcp.
   [...]
   GNU Emacs
   * TRAMP: (emacs-22/tramp).      Transparent Remote Access, Multiple Protocol 
                                     GNU Emacs remote file access via rsh and rcp.

And of course, between these headings appear some others that aren't
related to Emacs.  It's a pretty messy part of the Texinfo
infrastructure and would deserve to be improved.

        Stefan